class Array

	#
	#	٤ƤȤ߹碌᥽å
	#
	#		p [['A'], ['B', 'C'], ['D', 'E', 'F'], ['G', 'H', 'I', 'J']].combi
	#
	def combi(result = Array.new, temp = Array.new)
		if(self.size != 0)
			(remain = self.dup).shift.each {|c|
				remain.combi(result, temp + [c])
			}
		else
			result.push(temp)
		end
		return result
	end
end

class Guiter_chord

	@@KEYS = Array['C', 'C#', 'D', 'D#', 'E', 'F', 'F#', 'G', 'G#', 'A', 'A#', 'B']

#	Major-chord						:C				Ĺ3١û3			(5)
#	Minor-chord						:Cm				û3١Ĺ3			(5)
#	Dominant-7th-chord				:C7				Ĺ3١û3١û3	(û7)
#	Major-7th-chord					:Cmaj7			Ĺ3١û3١Ĺ3	(Ĺ7)
#	Minor-7th-chord					:Cm7			û3١Ĺ3١û3	(û7)
#	Minor-Major-7th-chord			:Cmmaj7			û3١Ĺ3١Ĺ3	(Ĺ7)

#	Major-6th-chord					:C6				Ĺ3١û3١Ĺ2	(Ĺ6)
#	Minor-6th-chord					:Cm6			û3١Ĺ3١Ĺ2	(Ĺ6)
#	Aug.-7th-chord					:Caug7	C7+5	Ĺ3١Ĺ3١û3	(û7١)

	@@RULES = Hash[
		'',		[0, 4, 3],
		'm',	[0, 3, 4],
		'7',	[0, 4, 3, 3],
		'M7',	[0, 4, 3, 4],
		'm7',	[0, 3, 4, 3],
	]

	@@OCTAVES = Array.new
	(0..6).each {|o|											# 6 octave
		@@KEYS.each {|k|
			@@OCTAVES.push("#{o}#{k}")
		}
	}

	@@FLETS = Array.new; h = 5
	@@FLETS.push(@@OCTAVES[28, h])	# string 1 open and 1-4 flet
	@@FLETS.push(@@OCTAVES[23, h])
	@@FLETS.push(@@OCTAVES[19, h])	# or 4?
	@@FLETS.push(@@OCTAVES[14, h])
	@@FLETS.push(@@OCTAVES[ 9, h])
	@@FLETS.push(@@OCTAVES[ 4, h])	# string 6

	#-----------------------------------------------------------
	#
	#	󥹥ȥ饯
	#
	def initialize(chord)
		@chord = chord
		@chord =~ /^([A-G]#?)(.*)/
		@base = $1; @type = $2
#		p @chord
		return @chord

# TODO
#  ưꤵ줿ɤˤϼФʤ褦ˤ

	end

	#-----------------------------------------------------------
	#
	#	ɤι
	#
	def resolve
		@elements = Array.new
		p = @@KEYS.index(@base)
		@@RULES[@type].each {|d|
			@elements.push(@@KEYS[(p += d) % 12])
		}
#		p @elements
		return @elements
	end

	#-----------------------------------------------------------
	#
	#	γƤ
	#
	#		١βϹԤ
	#		Ʊ2սǲ뤳Ȥ
	#		ۤʤ١(XonY)λԲ
	#
	def string_resolve
		self.resolve unless(@elements)

		@holds = Array.new
		(0..5).each {|ss| s = 5 - ss							# extract flet position for holds
			@@FLETS[s].each_index {|f|
				@holds.push([s, f, @@FLETS[s][f]]) if(@elements.index(@@FLETS[s][f][1, 9]))
			}
		}

		bstr = nil; @holds.delete_if {|h|						# resolve base string
			bstr ? h[0] == bstr : (h[2][1, 9] != @base ? true : (bstr = h[0] and false))
		}
#		p @holds
		return @holds
	end

	#-----------------------------------------------------------
	#
	#	٤ƤβĴ٤
	#
	def all_patterns
		self.string_resolve unless(@holds)

		string_has = Array.new
		s = nil; temp = Array.new								# ȤޤȤ
		@holds.each {|h|
			if(h[0] != s)
				string_has.push(temp) if(temp.size > 0)
				s = h[0]; temp = Array.new
			end
			temp.push(h)
		}
		string_has.push(temp) if(temp.size > 0)

		@patterns = string_has.combi							# ٤ƤβĴ٤

		@patterns.delete_if {|c|
			k = Hash.new; c.each {|f|							# ٤ƤΥޤޤƤ뤫
				k[f[2][1, 9]] = true								# ڥλθȤ褤
			}
			k.size != @elements.size
		}
#		p @patterns
		return @patterns
	end

	#-----------------------------------------------------------
	#
	#	䤹()¤٤֤
	#
	def sort_patterns
		self.all_patterns unless(@patterns)

		@patterns.each {|c|										# 䤹
			point = 100
			f = Hash.new; c.each {|k|
				point += 10 if(k[1] == 0)						# 
				point -= 10 if(k[1] != 0)						# ϸ
				f[k[1]] = true
			}
			point -= f.size * 20								# ϸ
			c.unshift(point)
		}

		@patterns.sort {|a, b| a[0] <=> b[0] }					# ¤ؤ

		@patterns.each {|c| c.shift }							# 

#		p @patterns
		return @patterns
	end

	#-----------------------------------------------------------
	#
	#	֤
	#
	def keys(holds)
		k = Array.new
		holds.each {|h|
			k.push(h[2])
		}
		return k
	end

	#-----------------------------------------------------------
	#
	#	֤
	#
	def diagram(holds)
		dgm = ''
		(0..5).each {|s|
			p = Array['x', '-', '-', '-', '-', '-', '-']
			holds.each {|h|
				p[h[1]] = 'o' and p[0] == 'x' and p[0] = ' ' if(h[0] == s)
#				p[h[1]] = "#{h[2]}" and p[0] == 'x' and p[0] = ' ' if(h[0] == s)
			}
			dgm += sprintf("%d: %2s |------%s-+------%s-+------%s-+------%s-+------%s-+------%s-+---\n", s + 1, *p)
#			dgm += sprintf("%d: %4s | %6s + %6s + %6s + %6s + %6s + %6s +\n", s + 1, *p)
		}
		return dgm
	end
end

